-- NPCEdit.lua
-- author: KirConjurer (angrykirc)

local intToPtr;
do
	local t = memAlloc(4)
	function intToPtr(num)
        	setPtrInt(t, 0, num)
        	return getPtrPtr(t, 0)
    	end
end -- thanks to Dio

--local host = getPtrPtr(ptrCall2(0x417090, intToPtr(31), intToPtr(1)), 0x808)
local userdata255 = intToPtr(255)

-- colorN: 0 - hair, 5 - skin
local function setNPCColor(npc, colorN, R, G, B)
    local uc = getPtrPtr(npc, 0x2EC)
    local offset = 2 * (colorN + 0x2B4) + colorN + 0x2B4
    setPtrByte(uc, offset, R)
    setPtrByte(uc, offset+1, G)
    setPtrByte(uc, offset+2, B)
    return
end

-- 0x5A0 actually is MobStatus
local function setNPCClass(npc, c1, c23)
    local uc = getPtrPtr(npc, 0x2EC)
    setPtrByte(uc, 0x534, c1)
    setPtrShort(uc, 0x5A0, c23)
    return
end

local spellUseFlags = { offensive = 0x40000000, defensive = 0x10000000, reaction = 0x08000000 }

local function setNPCSpell(npc, spell, useflag)
    local uc = getPtrPtr(npc, 0x2EC)
    local offset = 4 * spell + 0x5D0
    setPtrInt(uc, offset, useflag)
    return
end

local function equipWeapon(npc, item)
    return ptrCall2(0x53A2C0, npc, item)
end

local function equipArmor(npc, item)
    return ptrCall2(0x53E520, npc, item)
end

local function noxStr( str ) -- by Dio
 local size = #str
 local mem = memAlloc( size )
 setPtrByte( mem, size, 0 )
 for i=1, size do
  setPtrByte( mem, i-1, string.byte( str, i ) )
 end
 return mem
end

-- voice is actually a pointer to some structure
local function setNPCVoice(npc, voice)
    --[[local sp = noxStr(voice)
    local n = ptrCall2(0x424350, sp, sp)
    if (n) then
        return ptrCall2(0x424320, npc, n)
    else
        return nil
    end]]--
    local uc = getPtrPtr(npc, 0x2EC)
    setPtrInt(uc, 0x1E8, voice)
end

local function setNPCStrength(npc, val)
    local uc = getPtrPtr(npc, 0x2EC)
    setPtrByte(uc, 0x52C, val) -- 255 maximum
    return
end

local function setNPCMaxHealth(npc, val)
    local hd = getPtrPtr(npc, 0x22C)
    setPtrShort(hd, 0, val)
    setPtrShort(hd, 2, val)
    setPtrShort(hd, 4, val)
    return
end

-- float; default is 150
local function setNPCVisionR(npc, val)
    local uc = getPtrPtr(npc, 0x2EC)
    setPtrFloat(uc, 0x520, val)
    return
end

local function sendNPCData(npc)
    --if (host) then ptrCall2(0x4D93A0, host, npc) end
    return ptrCall2(0x4D93A0, userdata255, npc)
end

-- also look at: UC+0x14A - affects target accuracy


-- declare static class NPCEdit
NPCEdit = { 
spellFlags = spellUseFlags,
update = sendNPCData, 
setColor = setNPCColor, 
setClass = setNPCClass, 
setStrength = setNPCStrength, 
equipWeapon = equipWeapon, 
equipArmor = equipArmor, 
awardSpell = setNPCSpell, 
setMaxHP = setNPCMaxHealth,
setVoice = setNPCVoice, 
setRange = setNPCVisionR
}