-- most research on MonsterGenerator behavior was done by KirConjurer (AngryKirC)
-- 12.06.2014

local intToPtr;
do
	local t = memAlloc(4)
	function intToPtr(num)
        	setPtrInt(t, 0, num)
        	return getPtrPtr(t, 0)
    	end
end -- thanks to Dio

local emptyUserdata = intToPtr(1)

function createObjectSpec(thingtype)
    return ptrCall2(0x4E3450, intToPtr(thingtype), emptyUserdata)
end

local gendata = { spawnSpeed = 3, spawnLimit = 2, flags = 2, mobs = { "WizardWhite" } }

function testMGen(x, y)
    local z = createObject("WizardWhiteGenerator", x, y)
    unitMonsterGenerator(z, gendata)
    --if not unitMonsterGenerator(z, gendata) then unitDelete(z) end
    return z
end

function unitMonsterGenerator(mgen, data)
    local uc = getPtrPtr(mgen, 0x2EC)
    if (data.spawnLimit) then
        setPtrByte(uc, 0x53, data.spawnLimit)
    end
    if (data.spawnSpeed) then
        setPtrByte(uc, 0x50, data.spawnSpeed)
    end
    if (data.flags) then -- valid: 1, 2
        setPtrByte(uc, 0x5C, data.flags)
    else
        setPtrByte(uc, 0x5C, 0)
    end
    local pos = 0
    local obj
    local mobs = data.mobs
    if (not mobs) then return false end
    for i = 1, 10 do
        if (not mobs[i]) then return false end
        obj = createObjectSpec(getThingType(mobs[i]))
        if (not obj) then return false end
        setPtrPtr(uc, pos, obj)
        pos = pos + 4
        setPtrInt(uc, pos, 0)
    end
    return true
end