-- mobatest.lua
-- by KirConjurer (angrykirc)

-- constants
local spawnTimeout = 900 -- 30 sec
local goldTimeout = 150 -- 5 sec
local restockTimeout = 1800 -- 60 sec
local creepGoldReward = 500
local timeGoldReward = 50
local minimalKillReward = 200

-- variables
local redCreeps = {}
local blueCreeps = {}
local mobPoint1X = 1440
local mobPoint1Y = 4428
local mobPoint2X = 4336
local mobPoint2Y = 1530
local fountainX1 = 1345
local fountainY1 = 4520
local fountainX2 = 4450
local fountainY2 = 1414
local shopsSetUp = false
local captureX, captureY
-- shops
local skillShop1 = createObject("ShopkeeperWarriorsRealm", 750, 862)
local skillShop2 = createObject("ShopkeeperWizardRealm", 1208, 540)
local skillShopData = { { name = "AbilityBook", spell = 2 }, { name = "AbilityBook", spell = 3 },
 { name = "ConjurerSpellBook", spell = 77 },
 { name = "ConjurerSpellBook", spell = 92 },
 { name = "ConjurerSpellBook", spell = 96 },
 costMul = 14, sellMul = 0.001, dlgText = "guibook.c:ToolTipAbilityTab" }
local spellShop1 = createObject("ShopkeeperMagicShop", 1620, 1738)
local spellShop2 = createObject("ShopkeeperMagicShop", 2014, 1346)
local spellShopData = { 
{ name = "CommonSpellBook", spell = 41, num = 2 }, -- SPELL_LESSER_HEAL
{ name = "CommonSpellBook", spell = 72 }, -- SPELL_SLOW
{ name = "CommonSpellBook", spell = 38 }, -- SPELL_INVERSION
{ name = "CommonSpellBook", spell = 62 }, -- SPELL_PROTECTION_FROM_FIRE
{ name = "CommonSpellBook", spell = 61 }, -- SPELL_PROTECTION_FROM_ELECTRICITY
{ name = "CommonSpellBook", spell = 5 }, -- SPELL_BURN
{ name = "WizardSpellBook", spell = 24 }, -- SPELL_LIGHTNING
{ name = "WizardSpellBook", spell = 27 }, -- SPELL_FIREBALL
{ name = "ConjurerSpellBook", spell = 130 }, -- SPELL_VAMPIRISM
{ name = "ConjurerSpellBook", spell = 58 }, -- SPELL_PIXIE_SWARM
{ name = "ConjurerSpellBook", spell = 60 }, -- SPELL_POISON
{ name = "WizardSpellBook", spell = 34 }, -- SPELL_GLYPH
{ name = "WizardSpellBook", spell = 22 }, -- SPELL_DRAIN_MANA
{ name = "WizardSpellBook", spell = 50 }, -- SPELL_MAGIC_MISSILE
{ name = "WizardSpellBook", spell = 43 }, -- SPELL_CHAIN_LIGHTNING
{ name = "WizardSpellBook", spell = 51 }, -- SPELL_SHIELD
{ name = "WizardSpellBook", spell = 36 }, -- SPELL_HASTE
{ name = "ConjurerSpellBook", spell = 35 }, -- SPELL_GREATER_HEAL
{ name = "ConjurerSpellBook", spell = 52 }, -- SPELL_METEOR
costMul = 1.7, sellMul = 0.001, dlgText = "Con07B.scr:BookVendorTalk01" }
local armorShop1 = createObject("ShopkeeperYellow", 980, 4036)
local armorShop2 = createObject("ShopkeeperYellow", 3902, 1116)
local armorShopData = {
{ name = "LeatherHelm", e1 = "ArmorQuality2", e2 = "UserMaterialColor8" },
{ name = "LeatherArmbands", e1 = "ArmorQuality2", e2 = "UserMaterialColor8" },
{ name = "LeatherArmor", e1 = "ArmorQuality2", e2 = "UserMaterialColor8" },
{ name = "LeatherLeggings", e1 = "ArmorQuality2", e2 = "UserMaterialColor8" },
{ name = "LeatherArmoredBoots", e1 = "ArmorQuality2", e2 = "UserMaterialColor8" },
{ name = "ChainCoif", e1 = "ArmorQuality1", e2 = "Material2", e3 = "Regeneration2" },
{ name = "ChainTunic", e1 = "ArmorQuality1", e2 = "Material2", e3 = "Regeneration2" },
{ name = "ChainLeggings", e1 = "ArmorQuality1", e2 = "Material2", e3 = "Regeneration2"},
{ name = "LeatherHelm", e1 = "ArmorQuality4", e2 = "UserColor25", e3 = "Regeneration3", e4 = "Regeneration4" },
{ name = "LeatherArmbands", e1 = "ArmorQuality4", e2 = "UserColor25", e3 = "Regeneration3", e4 = "Regeneration4" },
{ name = "LeatherArmor", e1 = "ArmorQuality4", e2 = "UserColor25", e3 = "Regeneration3", e4 = "Regeneration4" },
{ name = "LeatherLeggings", e1 = "ArmorQuality4", e2 = "UserColor25", e3 = "Regeneration3", e4 = "Regeneration4" },
{ name = "LeatherArmoredBoots", e1 = "ArmorQuality3", e2 = "UserColor11", e3 = "Speed3", e4 = "Speed4" },
{ name = "LeatherArmoredBoots", e1 = "ArmorQuality4", e2 = "UserColor12", e3 = "Regeneration3", e4 = "Regeneration4" },
{ name = "ConjurerHelm", e1 = "ArmorQuality3", e2 = "UserColor27", e3 = "Speed2", e4 = "Brilliance1" },
{ name = "LeatherBoots", e1 = "ArmorQuality2", e3 = "Speed2" },
{ name = "WizardRobe", e1 = "ArmorQuality3", e3 = "UserMaterialColor13" },
{ name = "MedievalCloak", e1 = "ArmorQuality2", e3 = "Regeneration3", e4 = "Regeneration4"},
{ name = "MedievalCloak", e1 = "ArmorQuality2", e3 = "FireProtect3", e4 = "LightningProtect4"},
{ name = "OrnateHelm", e1 = "ArmorQuality2", e2 = "Material6" },
{ name = "PlateArms", e1 = "ArmorQuality2", e2 = "Material6" },
{ name = "Breastplate", e1 = "ArmorQuality2", e2 = "Material6" },
{ name = "PlateLeggings", e1 = "ArmorQuality2", e2 = "Material6" },
{ name = "PlateBoots", e1 = "ArmorQuality2", e2 = "Material6" },
{ name = "SteelShield", e1 = "ArmorQuality3", e2 = "Material6", e3 = "Regeneration2", e4 = "Regeneration3" },
{ name = "SteelShield", e1 = "ArmorQuality2", e2 = "Material6", e3 = "Speed2", e4 = "Speed3" },
costMul = 1.4, sellMul = 0.001, dlgText = "Con05A.scr:GypsyGreeting" }
local weaponShop1 = createObject("ShopkeeperLandOfTheDead", 1758, 4780)
local weaponShop2 = createObject("ShopkeeperLandOfTheDead", 4686, 1866)
local weaponShopData = {
{ name = "Longsword", e1 = "WeaponPower3", e2 = "UserColor15", e3 = "Fire2", e4 = "Vampirism3" },
{ name = "Longsword", e1 = "WeaponPower3", e2 = "UserColor20", e3 = "Lightning2", e4 = "Venom3" },
{ name = "Sword", e1 = "WeaponPower5", e2 = "UserColor30", e3 = "ManaSteal3" },
{ name = "StaffWooden", e1 = "WeaponPower4", e2 = "UserColor10", e3 = "Impact1" },
{ name = "MorningStar", e1 = "WeaponPower3", e2 = "UserColor3", e3 = "Impact1" },
{ name = "MorningStar", e1 = "WeaponPower4", e2 = "UserColor8", e3 = "Vampirism3", e4 = "Impact1" },
{ name = "StaffWooden", e1 = "WeaponPower2", e2 = "UserColor14", e3 = "Vampirism3" },
{ name = "BattleAxe", e1 = "WeaponPower3", e2 = "UserColor27", e3 = "Confuse1" },
{ name = "Bow", e2 = "UserColor27", e3 = "Readiness1" },
{ name = "Bow", e2 = "UserColor23", e3 = "ProjectileSpeed2" },
{ name = "GreatSword", e1 = "WeaponPower3", e2 = "UserColor22", e3 = "Vampirism2", e4 = "Vampirism3" },
{ name = "GreatSword", e1 = "WeaponPower4", e2 = "UserMaterialColor13", e3 = "Lightning3" },
costMul = 2.2, sellMul = 0.001, dlgText = "Con05A.scr:ShopKeeperGreeting" } 
local wandShop1 = createObject("ShopkeeperWizardRealm", 1730, 4832)
local wandShop2 = createObject("ShopkeeperWarriorsRealm", 4750, 1826)
local wandShopData = {
{ name = "Quiver", e1 = "WeaponPower2", num = 5 },
{ name = "Quiver", e1 = "WeaponPower1", e3 = "Venom3" },
{ name = "Quiver", e1 = "WeaponPower1", e3 = "ManaSteal3" },
{ name = "Quiver", e1 = "WeaponPower3", e3 = "Fire3" },
{ name = "FanChakram", e1 = "WeaponPower2", num = 4 },
{ name = "FanChakram", e1 = "WeaponPower1", e2 = "UserColor21", e3 = "Lightning2", e4 = "ManaSteal3" },
{ name = "ForceWand" },
{ name = "LesserFireballWand" },
{ name = "Meat", num = 3 },
{ name = "RedApple", num = 6 },
costMul = 1.05, sellMul = 0.001, dlgText = "Journal:Wiz6Bull" }
local secretShop1 = createObject("ShopkeeperPurple", 2074, 2960)
local secretShop2 = createObject("ShopkeeperPurple", 3626, 2980)
local secretShopData = {
{ name = "DeathRayWand" },
{ name = "FireStormWand" },
{ name = "WarHammer", e1 = "WeaponPower1" },
{ name = "WarHammer", e1 = "WeaponPower2", e2 = "UserColor3", e3 = "Stun1" },
{ name = "Sword", e1 = "WeaponPower6", e2 = "UserColor5", e3 = "ManaSteal3", e4 = "ManaSteal4" },
{ name = "WizardSpellBook", spell = 39 }, -- SPELL_INVISIBILITY
{ name = "ConjurerSpellBook", spell = 29 }, -- SPELL_INVISIBILITY
{ name = "ConjurerSpellBook", spell = 31 }, -- SPELL_FORCE_OF_NATURE
{ name = "WizardSpellBook", spell = 71 }, -- SPELL_SHOCK
{ name = "WizardSpellBook", spell = 16 }, -- SPELL_DEATH_RAY
{ name = "ConjurerSpellBook", spell = 87 }, -- SPELL_SUMMON_IMP
{ name = "ConjurerSpellBook", spell = 75 }, -- SPELL_SUMMON_BAT
{ name = "ConjurerSpellBook", spell = 102 }, -- SPELL_SUMMON_TROLL
{ name = "MedievalCloak", e1 = "ArmorQuality2", e3 = "Speed2", e4 = "Speed3"},
{ name = "WizardHelm", e1 = "ArmorQuality2", e3 = "Speed1", e4 = "Speed2"},
{ name = "CrossBow", e3 = "Readiness2", e4 = "Impact2" },
{ name = "RedPotion", num = 3 },
{ name = "BluePotion", num = 3 },
costMul = 5, sellMul = 0.001, dlgText = "Con05A.scr:ShopKeeperTalk1" }
-- imports 
dofile('.\\scripts\\unitUtil.lua')
dofile('.\\scripts\\shopkeeper.lua')
dofile('.\\scripts\\gameFix.lua')
dofile('.\\scripts\\commentbot.lua')

local function setActionMove(mob, x, y)
    local t = unitSetAction(mob, 8) -- ACTION_FAR_MOVE_TO
    -- if i use ACTION_MOVE_TO mobs dont't attack anyone
    setPtrFloat(t, 4, x)
    setPtrFloat(t, 8, y)
    return t
end

local function setActionGuard(mob, x, y)
    local t = unitSetAction(mob, 4) -- ACTION_GUARD
    setPtrFloat(t, 4, x)
    setPtrFloat(t, 8, y)
    return t
end

local function forbidSpells(player)
	local objCtrl = getPtrPtr(player, 0x2ec)
	local plrInfo = getPtrPtr(objCtrl, 0x114)
    local offset
    for i = 1, 137 do
        offset = 4 * i + 0xe70
        setPtrInt(plrInfo, offset, 0)
    end
end

local function playerClaimLoot(plr)
    local flags
    local team = unitGetTeam(plr)
    for item in getInv(plr) do
        unitSetTeam(item, team)
    end
    return true
end

function playerDamageHandler(victim, attacker, unk, damage, dtype)
    if (unitIsOn(victim)) then
        local health = getPtrShort(getPtrPtr(victim, 0x22C), 0)
        if (damage >= health) then
            local gold = playerGetGold(victim)
            gold = math.floor(gold / 4)
            playerSubGold(victim, gold)
            if (attacker) then
                if (bitAnd(getUnitClass(attacker), 4) > 0) then
                    if (gold < minimalKillReward) then gold = minimalKillReward end
                    if (unitGetTeam(attacker) == unitGetTeam(victim)) then return end -- fix
                    --if (bitAnd(unitFlags(victim), 0x8000) == 0) then return end
                    playerAddGold(attacker, gold)
                    commentKill(victim, attacker, gold)
                end
            end
        end
        playerClaimLoot(victim)
    end
    return false
end

local function tryUnsetPlrHandler(plr)
    unitOnDamage(plr, nil)
end -- unitOnDie is bugged :(

function setupPlayer(player)
    forbidSpells(player)
    playerSubGold(player, 9000000)
    pcall(tryUnsetPlrHandler, player) -- safe call
    unitOnDamage(player, playerDamageHandler)
    return true
end

function setupAllPlayers()
	local players = playerList()
    local user
	
	for p = 0, #players do
		user = players[p]
		if (user) then
			setupPlayer(user)
		end
	end
end

--playerOnJoin = function(pinfo)
--	setTimeout(function() lastJoined = getPtrPtr(pinfo, 0x808) setupPlayer(lastJoined) end, 30)
--end

playerOnLeaveObs = function(plr)
    setupPlayer(plr)
end

local function setupShops()
    setActionGuard(skillShop1, unitPos(skillShop1))
    setActionGuard(skillShop2, unitPos(skillShop2))
    setActionGuard(spellShop1, unitPos(spellShop1))
    setActionGuard(spellShop2, unitPos(spellShop2))
    setActionGuard(armorShop1, unitPos(armorShop1))
    setActionGuard(armorShop2, unitPos(armorShop2))
    setActionGuard(weaponShop1, unitPos(weaponShop1))
    setActionGuard(weaponShop2, unitPos(weaponShop2))
    setActionGuard(wandShop1, unitPos(wandShop1))
    setActionGuard(wandShop2, unitPos(wandShop2))
    setActionGuard(secretShop1, unitPos(secretShop1))
    setActionGuard(secretShop2, unitPos(secretShop2))
    shopsSetUp = true
    return true
end

function updateShopkeepers()
    setTimeout(updateShopkeepers, restockTimeout)
    if not shopsSetUp then
        setTimeout(setupShops, 1)
    end
    shopCreate(skillShop1, skillShopData)
    shopCreate(skillShop2, skillShopData)
    shopCreate(spellShop1, spellShopData)
    shopCreate(spellShop2, spellShopData)
    shopCreate(armorShop1, armorShopData)
    shopCreate(armorShop2, armorShopData)
    shopCreate(weaponShop1, weaponShopData)
    shopCreate(weaponShop2, weaponShopData)
    shopCreate(wandShop1, wandShopData)
    shopCreate(wandShop2, wandShopData)
    shopCreate(secretShop1, secretShopData)
    shopCreate(secretShop2, secretShopData)
    return
end

local function onCreepDeath(creep, attacker)
    if (attacker) then
        unitDecay(creep, 30)
        if (bitAnd(getUnitClass(attacker), 4) > 0) then
            playerAddGold(attacker, creepGoldReward)
            soundMake(307, unitPos(creep))
        end -- give gold only to players
    end
    return false
end

local function setupCreeps1()
    local mob
    for i = 1, #redCreeps do
        mob = redCreeps[i]
        if (mob) then
            unitSetTeam(mob, 1)
            unitHP(mob, unitHP(mob) * 2)
            unitSetAgression(mob, 0.83)
            unitOnDie(mob, onCreepDeath)
            setActionMove(mob, mobPoint2X, mobPoint2Y)
        end
    end
    return
end

local function setupCreeps2()
    local mob
    for i = 1, #blueCreeps do
        mob = blueCreeps[i]
        if (mob) then
            unitSetTeam(mob, 2)
            unitHP(mob, unitHP(mob) * 2)
            unitSetAgression(mob, 0.83)
            unitOnDie(mob, onCreepDeath)
            setActionMove(mob, mobPoint1X, mobPoint1Y)
        end
    end
    return
end

function givePeriodicGold()
    setTimeout(givePeriodicGold, goldTimeout)
    local plrs = playerList()
    local plr
    for i = 1, #plrs do
        plr = plrs[i]
        if (plr) then
            if (bitAnd(unitFlags(plr), 0x8000) > 0) then return end -- dead players can't earn gold
            playerAddGold(plr, timeGoldReward)
        end
    end
    return
end

function spawnCreeps()
    setTimeout(spawnCreeps, spawnTimeout)
    local mob
    for i = 1, 6 do 
        mob = createObject("Swordsman", mobPoint1X, mobPoint1Y)
        redCreeps[i] = mob
        mob = createObject("Swordsman", mobPoint2X, mobPoint2Y)
        blueCreeps[i] = mob
    end
    for i = 7, 9 do
        mob = createObject("Archer", mobPoint1X, mobPoint1Y)
        redCreeps[i] = mob
        mob = createObject("Archer", mobPoint2X, mobPoint2Y)
        blueCreeps[i] = mob
    end
    setTimeout(setupCreeps1, 1)
    setTimeout(setupCreeps2, 1)
    return
end

local function fountain1Attack(unit)
    if not unitIsOn(unit) then return end
    local x2, y2 = unitPos(unit)
    if (unitGetTeam(unit) ~= 1 and bitAnd(unitFlags(unit), 0x8000) == 0) then 
        if (bitAnd(getUnitClass(unit), 4) > 0) then
            netRayFx(0x95, fountainX1, fountainY1, x2, y2)
            unitDamage(unit, 5)
        elseif (bitAnd(getUnitClass(unit), 2) > 0) then
            netRayFx(0x94, fountainX1, fountainY1, x2, y2)
            unitDelete(unit, 30)
        end
    end
    return false
end

local function fountain2Attack(unit)
    if not unitIsOn(unit) then return end
    local x2, y2 = unitPos(unit)
    if (unitGetTeam(unit) ~= 2 and bitAnd(unitFlags(unit), 0x8000) == 0) then
        if (bitAnd(getUnitClass(unit), 4) > 0) then
            netRayFx(0x95, fountainX2, fountainY2, x2, y2)
            unitDamage(unit, 5)
        elseif (bitAnd(getUnitClass(unit), 2) > 0) then
            netRayFx(0x94, fountainX2, fountainY2, x2, y2)
            unitDelete(unit, 30)
        end
    end
end
    
function fountainFindTargets()
    setTimeout(fountainFindTargets, 3)
    unitGetAround(fountain1Attack, fountainX1-200, fountainY1-200, fountainX1+200, fountainY1+200)
    unitGetAround(fountain2Attack, fountainX2-200, fountainY2-200, fountainX2+200, fountainY2+200)
    return
end

local function distance(x1, y1, x2, y2)
    local dx = x1 - x2
    local dy = y1 - y2
    return math.sqrt(dx * dx + dy * dy)
end

function captureEnd(plr, team)
    local pX, pY = unitPos(plr)
    if (distance(captureX, captureY, pX, pY) > 35) then
        sendChat(-1, "Capture failed: Too far away!", servNetCode(plr), false)
        return
    end
    if (bitAnd(unitFlags(plr), 0x8000) == 0) then
        teamScore(team, 100)
    end
    return
end
        
function scoreAdd1()
    if not scriptParent then return end
    if unitGetTeam(scriptParent) ~= 2 then
        sendChat(-1, "This is a capture point. Defend it from enemy players!", servNetCode(scriptParent), false)
    else
        captureX, captureY = unitPos(scriptParent)
        sendChat(-1, "Capturing the point now!", servNetCode(scriptParent), false)
        setTimeout(function() captureEnd(scriptParent, 2) end, 4 * 30)
    end
    return true
end

function scoreAdd2()
    if not scriptParent then return end
    if unitGetTeam(scriptParent) ~= 1 then 
        sendChat(-1, "This is a capture point. Defend it from enemy players!", servNetCode(scriptParent), false)
    else
        captureX, captureY = unitPos(scriptParent)
        sendChat(-1, "Capturing the point now!", servNetCode(scriptParent), false)
        setTimeout(function() captureEnd(scriptParent, 1) end, 4 * 30)
    end
    return true
end

commentRandom() -- start chatter bot
updateShopkeepers() -- start shopkeeper restock cycle
setupAllPlayers() -- set up all players
-- BUGGED! noDeathItemDrop()
disableItemRespawning()
fixAbilityLvlCheck() -- disable warrior abilities
fixSpellPowerJNE() -- fix spell power
spawnCreeps() -- start creep spawning cycle
givePeriodicGold()
fountainFindTargets()